import createFactory from './create-factory';
import mapShape from './map-shape';
import validateShapeMap from './validate-shape-map';
import { deepMerge } from './util';

var shapeWith = function shapeWith(pathMap) {
  var mapper = mapShape(pathMap);

  return function (BaseComponent) {
    var factory = createFactory(BaseComponent);

    return function (props) {
      return factory(deepMerge(props, mapper(props)));
    };
  };
};

export default validateShapeMap(shapeWith);