'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createFactory = require('./create-factory');

var _createFactory2 = _interopRequireDefault(_createFactory);

var _mapShape = require('./map-shape');

var _mapShape2 = _interopRequireDefault(_mapShape);

var _validateShapeMap = require('./validate-shape-map');

var _validateShapeMap2 = _interopRequireDefault(_validateShapeMap);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var shapeWith = function shapeWith(pathMap) {
  var mapper = (0, _mapShape2.default)(pathMap);

  return function (BaseComponent) {
    var factory = (0, _createFactory2.default)(BaseComponent);

    return function (props) {
      return factory((0, _util.deepMerge)(props, mapper(props)));
    };
  };
};

exports.default = (0, _validateShapeMap2.default)(shapeWith);